<id>
Persnonal Notepad for YaBB 2.6.0
</id>

<version>
0.6
</version>

<mod info>
Description
-----------
Adds a Personal Notepad to the User CP

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Go to 'Admin Center - Forum Settings - Members - Profile' to enable this feature.

Files to edit
-------------
Admin/ModList.pm
Admin/NewSettings.pm
Admin/Settings_Main.pm
Languages/English/Admin.lng
Languages/English/Profile.lng
Sources/MyCenter.pm
Sources/Profile.pm
Sources/SubList.pm
Sources/System.pm
Templates/default/MyCenter.template

Version History
---------------
V0.1 - First release - 23rd November 2009
V0.2 - Added Spell Checking (if enabled) - 24th November 2009
V0.3 - Tidied up textarea - 25th November 2009
V0.4 - Added auto-focus if textarea is empty - 14th December 2009
V0.5 - Updated for YaBB 2.5 and made changes so that notes can only be viewed by the user - 16th July 2010
V0.6 - Updated for YaBB 2.6.0 by Dandello - 9th July, 2014
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $mod_personalpad = "Personal Notepad|Derek Barnstorm, updated for 2.6.0 for 2.6.0|Adds a Personal Notepad to the User CP|0.6|9th July 2014";
    push (@installed_mods, "$mod_personalpad");
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
\$MaxSigLen = $MaxSigLen;                   # Maximum Allowed Characters in Signatures
</search for>

<add before>
### Personal Notepad Mod Start ###
\$PersonalPadEnabled = $PersonalPadEnabled;         # Enable Personal Notepad
\$MaxNotesLen = $MaxNotesLen;            # Maximum Allowed Characters in Personal Notepad
### Personal Notepad Mod End ###
</add before>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
if ($ML_Allowed eq q{}) { $ML_Allowed = 1;}
</search for>

<add after>
if ( $MaxNotesLen eq q{} ) { $MaxNotesLen = 2000; } ### Personal Notepad Mod ###
</add after>

<search for>
            name => 'buddyListEnabled',
            validate => 'boolean',
        },
</search for>

<add after>
        ### Personal Notepad Mod Start ###
        {
            description => qq~<label for="PersonalPadEnabled">$admin_txt{'personalpad'}</label>~,
            input_html => qq~<input type="checkbox" name="PersonalPadEnabled" id="PersonalPadEnabled" value="1"${ischecked($PersonalPadEnabled)} />~,
            name => 'PersonalPadEnabled',
            validate => 'boolean',
        },
        {
            description => qq~<label for="MaxNotesLen">$admin_txt{'689b'}</label>~,
            input_html => qq~<input type="text" name="MaxNotesLen" id="MaxNotesLen" size="5" value="$MaxNotesLen" />~,
            name => 'MaxNotesLen',
            validate => 'number,null',
        },
        ### Personal Notepad Mod End ###
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'689a' => 'Maximum allowed characters in Away message',
</search for>

<add after>
'689b' => 'Maximum allowed characters in Personal Notepad', ### Personal Notepad Mod ###
</add after>

<search for>
'buddylist' => 'Enable Buddy List?',
</search for>

<add after>
'personalpad' => 'Enable Personal Notepad?', ### Personal Notepad Mod ###
</add after>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
);

%mycenter_profile_txt = (
</search for>

<add before>
### Personal Notepad Mod Start ###
'notepad' => 'Personal Notepad',
'savenotes' => 'Save Notes',
'maxnotes' => "Max $MaxNotesLen characters. Remaining characters: ",
### Personal Notepad Mod End ###
</add before>

<search for>
1;
</search for>

<add before>
### Personal Notepad Mod Start ###
%spell_check = (
'chck_spell' => 'Check spelling',
'revert' => 'Revert to',
'close' => 'Close',
'rsm_edt' => 'Resume editing',
'no_error_found' => 'No spelling errors found',
'no_suggestions' => 'No suggestions found',
);
### Personal Notepad Mod End ###

</add before>

<edit file>
Sources/MyCenter.pm
</edit file>

<search for>
        $my_IMpref = $my_thislink_impref;
        $my_IMpref =~ s/{yabb thisLink_f}/$thisLink_f/sm;
    }
</search for>

<add after>

    ### Personal Notepad Mod Start ###
    if ($PersonalPadEnabled) {
        $thisLink = $profileLink . 'myprofileNotepad;username=' . $useraccount{$username} . $sidLink;
        $myPPad = qq~
        <span class="nav"><b><a href="$scripturl?$thisLink">$profile_txt{'notepad'}</a></b></span><br />~;
    }
    ### Personal Notepad Mod End ###
</add after>

<search for>
        elsif ( $action eq 'myprofileBuddy2' )    { ModifyProfileBuddy2(); }
</search for>

<add after>
        ### Personal Notepad Mod Start ###
        elsif ( $action eq 'myprofileNotepad' )  { ModifyProfileNotepad(); }
        elsif ( $action eq 'myprofileNotepad2' ) { ModifyProfileNotepad2(); }
        ### Personal Notepad Mod End ###
</add after>

<search for>
    $MCProfMenu =~ s/{yabb my_IMpref}/$my_IMpref/sm;
</search for>

<add after>
    $MCProfMenu =~ s/{yabb myPPad}/$myPPad/sm;
</add after>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
sub ModifyProfileAdmin {
</search for>

<add before>
### Personal Notepad Mod Start ###
sub ModifyProfileNotepad {
    SidCheck($action);
    PrepareProfile();

    ProfileMenu();

    $scriptAction = qq~myprofileNotepad2~;
    $yytitle = qq~$profile_txt{'editmyprofile'} &rsaquo; $profile_txt{'notepad'}~;
    $profiletitle = qq~$profile_txt{'editmyprofile'} ($user) &rsaquo; $profile_txt{'notepad'}~;
    $yynavigation = qq~&rsaquo; <a href="$scripturl?action=mycenter" class="nav">$img_txt{'mycenter'}</a> &rsaquo; $profiletitle~;

    $personalpad = ${$uid.$user}{'personalpad'};
    $personalpad =~ s/<br \/>/\n/gsm;

    # SpellChecker start
    if ($enable_spell_check) {
        $yyinlinestyle .= qq~<link href="$yyhtml_root/googiespell/googiespell.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="$yyhtml_root/AJS.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/googiespell.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/cookiesupport.js"></script>~;
        my $userdefaultlang = (split(/-/, $abbr_lang))[0];
        $userdefaultlang ||= 'en';
        $personalpad_spellcheck .= qq~
        GOOGIE_DEFAULT_LANG = '$userdefaultlang';
        var googie1 = new GoogieSpell("$yyhtml_root/googiespell/", "$boardurl/Sources/SpellChecker.pl?lang=");
        googie1.lang_chck_spell = '$spell_check{'chck_spell'}';
        googie1.lang_revert = '$spell_check{'revert'}';
        googie1.lang_close = '$spell_check{'close'}';
        googie1.lang_rsm_edt = '$spell_check{'rsm_edt'}';
        googie1.lang_no_error_found = '$spell_check{'no_error_found'}';
        googie1.lang_no_suggestions = '$spell_check{'no_suggestions'}';
        googie1.setSpellContainer("spell_container");
        googie1.decorateTextarea("personalpad");~;
        $personalpad_spelldiv = qq~<div style="width: 98%; padding-bottom: 3px; text-align: right;" id="spell_container"></div>~;
    }
    # SpellChecker end

    $showProfile .= qq~
<form action="$scripturl?action=$scriptAction;username=$useraccount{$INFO{'username'}};sid=$INFO{'sid'}" method="post" name="creator">
<table class="cs_thin pad_4px">
    <tr>
        <td class="catbg"><img src="$imagesdir/profile.gif" alt="" /> <b>$profiletitle</b></td>
    </tr>
    <tr class="windowbg">
        <td class="center">
        $personalpad_spelldiv
        <textarea cols="80" rows="15" style="width: 98%; padding: 3px;" name="personalpad" id="personalpad">$personalpad</textarea>
        <br />
        <span class="small">$profile_txt{'maxnotes'} <input value="$MaxNotesLen" size="3" name="msgCL" class="windowbg" style="border: 0px; width: 40px; padding: 1px; font-size: 11px;" readonly="readonly" /></span>
        <script type="text/javascript">
            if (document.creator.personalpad.value == "") {
                document.creator.personalpad.focus();
            }
            var supportsKeys = false;
            function tick() {
                calcCharLeft(document.forms[0]);
                if (!supportsKeys) { timerID = setTimeout("tick()", 1500); }
            }
            function calcCharLeft(personalpad) {
                clipped = false;
                maxLength = $MaxNotesLen;
                if (document.creator.personalpad.value.length > maxLength) {
                    document.creator.personalpad.value = document.creator.personalpad.value.substring(0,maxLength);
                    charleft = 0;
                    clipped = true;
                } else {
                    charleft = maxLength - document.creator.personalpad.value.length;
                }
                document.creator.msgCL.value = charleft;
                return clipped;
            }
            tick();
            $personalpad_spellcheck
        </script>
    </td>
    </tr>
    <tr class="catbg">
        <td class="center" style="height:50px"><input type="submit" name="moda" value="$profile_txt{'savenotes'}" class="button" /><br /><span class="small">$expiretxt</span></td>
    </tr>
</table>
</form>~;
}

### Personal Notepad Mod End ###

</add before>

<search for>
    if ( $pm_lev == 1 ) {
        $scriptAction = q~profileIM~;
    }
    if ($buddyListEnabled) {
        $scriptAction = q~profileBuddy~;
    }
</search for>

<add before>
    ### Personal Notepad Mod Start ###
    if ($PersonalPadEnabled && $view) {
        $scriptAction = qq~profileNotepad~;
    }
    ### Personal Notepad Mod End ###
</add before>

<search for>
    ${ $uid . $user }{'buddylist'} = $member{'buddylist'};
    UserAccount( $user, 'update' );

    my $scriptAction;
    if (
        $iamadmin
        || (   $iamgmod
            && $allow_gmod_profile
            && $gmod_access2{'profileAdmin'} eq 'on' )
      )
    {
        $scriptAction = q~profileAdmin~;
    }
    else {
        $scriptAction = q~viewprofile~;
    }
</search for>

<add after>
    ### Personal Notepad Mod Start ###
    if ($PersonalPadEnabled && $view) {
        $scriptAction = qq~profileNotepad~;
    }
    ### Personal Notepad Mod End ###
</add after>

<search for>
    my $scriptAction = q~viewprofile~;
    if (
        $iamadmin
        || (   $iamgmod
            && $allow_gmod_profile
            && $gmod_access2{'profileAdmin'} eq 'on' )
      )
    {
        $scriptAction = q~profileAdmin~;
    }
    if ($view) { $scriptAction = qq~my$scriptAction~; }
    $yySetLocation =
qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
    redirectexit();
    return;
}
</search for>

<replace>
    ### Personal Notepad Mod Edit Start ###
    my $scriptAction;
    if (
        $iamadmin
        || (   $iamgmod
            && $allow_gmod_profile
            && $gmod_access2{'profileAdmin'} eq 'on')
      )
    {
        $scriptAction = qq~profileAdmin~;
    }
    else {
        $scriptAction = qq~viewprofile~;
    }
    if ( $PersonalPadEnabled && $view ) {
        $scriptAction = qq~profileNotepad~;
    }
    if ( $view ) { $scriptAction = qq~my$scriptAction~; }
    $yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
    redirectexit();
    return;
}

sub ModifyProfileNotepad2 {
    SidCheck($action);
    PrepareProfile();

    my (%member, $key, $value);
    while (($key, $value) = each(%FORM)) {
        $value =~ s~\A\s+~~;
        $value =~ s~\s+\Z~~;
        $member{$key} = $value;
    }
    $member{'username'} = $user;

     if ( $member{'moda'} ne $profile_txt{'savenotes'} ) { fatal_error('not_allowed'); }

    FromChars($member{'personalpad'});
    ToHTML($member{'personalpad'});
    $member{'personalpad'} =~ s~[\n\r]{1,2}~<br />~g;
    $convertstr = $member{'personalpad'};
    $convertcut = $MaxNotesLen;
    CountChars();
    $member{'personalpad'} = $convertstr;
    ToChars($member{'personalpad'});
    ${$uid.$user}{'personalpad'} = $member{'personalpad'};

    if ($extendedprofiles) { # run this before you start to save something!
        require Sources::ExtendedProfiles;
        my $error = ext_validate_submition($username,$user);
        if ($error ne "") { fatal_error("extended_profiles_validation",$error); }
        ext_saveprofile($user);
    }

    UserAccount($user, 'update');

    my $scriptAction = qq~viewprofile~;
    if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
        $scriptAction = qq~profileAdmin~;
    }
    if ($view) { $scriptAction = qq~my$scriptAction~; }
    $yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
    redirectexit();
    return;
}
    ### Personal Notepad Mod Edit End ###
</replace>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
'myprofileIM2','MyCenter.pm&mycenter',
</search for>

<add after>
### Personal Notepad Mod Start ###
'myprofileNotepad','MyCenter.pm&mycenter',
'myprofileNotepad2','MyCenter.pm&mycenter',
### Personal Notepad Mod End ###
</add after>

<edit file>
Sources/System.pm
</edit file>

<search for>
    if ($extendedprofiles) {
        require Sources::ExtendedProfiles;
        push @tags, ext_get_fields_array();
    }
</search for>

<add before>
    push @tags, 'personalpad'; ### Personal Notepad Mod ###
</add before>

<edit file>
Templates/default/MyCenter.template
</edit file>

<search for>
                <br />{yabb my_buddylink}{yabb my_IMpref}{yabb my_adminlink}
</search for>

<replace>
                <br />{yabb my_buddylink}{yabb my_IMpref}{yabb myPPad}{yabb my_adminlink}
</replace>